
Ruby - Bug #19563

Ripper.tokenize(code).join != code when heredoc and multiline %w[] literal is on the same line

03/31/2023 11:47 AM - tompng (tomoya ishida)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.3.0dev (2023-03-29T21:57:52Z

master 1b06422767) [x86_64-linux]

Backport: 3.0: REQUIRED, 3.1: REQUIRED, 3.2:

REQUIRED

Description

Ripper.tokenize "<<EOF || %w[hello\nEOF\n\n\n\nworld]"

# actual result

["<<EOF", " ", "||", " ", "%w[", "hello", "\n\n\n\n", "EOF\n", "world", "]"]

# expected result

["<<EOF", " ", "||", " ", "%w[", "hello", "\n", "EOF\n", "\n\n\n", "world", "]"]

 same for %i[] literal.

Related issues:

Related to Ruby - Bug #19544: Custom quotes inconsistency Closed

Associated revisions

Revision ac8a16237c727ae2a1446ef6dc810d0e750971fb - 04/07/2023 02:13 PM - nobu (Nobuyoshi Nakada)

[Bug #19563] Yield words separators per lines

So that newlines across a here-doc terminator will be separated

tokens.

Cf. https://github.com/ruby/irb/pull/558

Revision ac8a16237c727ae2a1446ef6dc810d0e750971fb - 04/07/2023 02:13 PM - nobu (Nobuyoshi Nakada)

[Bug #19563] Yield words separators per lines

So that newlines across a here-doc terminator will be separated

tokens.

Cf. https://github.com/ruby/irb/pull/558

Revision ac8a1623 - 04/07/2023 02:13 PM - nobu (Nobuyoshi Nakada)

[Bug #19563] Yield words separators per lines

So that newlines across a here-doc terminator will be separated

tokens.

Cf. https://github.com/ruby/irb/pull/558

History

#1 - 04/01/2023 01:08 PM - nobu (Nobuyoshi Nakada)

Similar for Unicode codepoints.

p Ripper.tokenize("<<EOS || %[\\u{4a\n""EOS\n\n\n\n""5a}]").join("")

# "<<EOS || %[EOS\n\n\n\n5a}]"

#2 - 04/01/2023 01:50 PM - nobu (Nobuyoshi Nakada)

- File 0001-Bug-19563-Yield-words-separators-per-lines.patch added

The attached patch fails in an IRB test.

I'm not sure about this prompt transition, should this be fixed as expected?

As the line 004 ends the heredoc C but is inside %W[, isn't ] ok here?
[25/39] TestIRB::TestRubyLex#test_heredoc_with_embexpr = 0.00 s                                       

  1) Failure:

TestIRB::TestRubyLex#test_heredoc_with_embexpr [/Users/nobu/src/ruby/master/src/test/irb/test_ruby_lex.rb:246]

:

Expected dynamic prompt:

001:0:":* 

002:0:":* 

003:0:":* 

004:0:":* 

005:0:]:* 

006:0:":* 

007:0:":* 

008:0:":* 

009:0:]:* 

010:0:]:* 

011:0: :> 

012:0: :* 

Actual dynamic prompt:

001:0:":* 

002:0:":* 

003:0:":* 

004:0:]:* 

005:0:]:* 

006:0:":* 

007:0:":* 

008:0:":* 

009:0:]:* 

010:0:]:* 

011:0: :> 

012:0: :* 

.

<["001:0:\":* ",

 "002:0:\":* ",

 "003:0:\":* ",

 "004:0:\":* ",

 "005:0:]:* ",

 "006:0:\":* ",

 "007:0:\":* ",

 "008:0:\":* ",

 "009:0:]:* ",

 "010:0:]:* ",

 "011:0: :> ",

 "012:0: :* "]> expected but was

<["001:0:\":* ",

 "002:0:\":* ",

 "003:0:\":* ",

 "004:0:]:* ",

 "005:0:]:* ",

 "006:0:\":* ",

 "007:0:\":* ",

 "008:0:\":* ",

 "009:0:]:* ",

 "010:0:]:* ",

 "011:0: :> ",

 "012:0: :* "]>.

#3 - 04/06/2023 01:35 PM - tompng (tomoya ishida)

I've opend a pull request to fix irb's test. Changes expected prompt and target code to avoid this bug in ruby 2.7~3.2.

https://github.com/ruby/irb/pull/558

#4 - 04/07/2023 12:49 PM - tompng (tomoya ishida)

I merged irb's pull request. I think the failing test is fixed now.

#5 - 04/07/2023 02:14 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|ac8a16237c727ae2a1446ef6dc810d0e750971fb.

[Bug #19563] Yield words separators per lines
So that newlines across a here-doc terminator will be separated

tokens.

Cf. https://github.com/ruby/irb/pull/558

#6 - 04/11/2023 10:16 AM - nagachika (Tomoyuki Chikanaga)

MEMO: 4af9bd52cbb8cff7d149a8565012ab1153a4b5b1 is the follow-up commit for ac8a16237c727ae2a1446ef6dc810d0e750971fb.

#7 - 07/11/2023 01:30 PM - nobu (Nobuyoshi Nakada)

- Related to Bug #19544: Custom quotes inconsistency added

#8 - 07/11/2023 01:31 PM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 3.0: REQUIRED, 3.1: REQUIRED, 3.2: REQUIRED

Files

0001-Bug-19563-Yield-words-separators-per-lines.patch 4.35 KB 04/01/2023 nobu (Nobuyoshi Nakada)

Powered by TCPDF (www.tcpdf.org)

07/17/2025 3/3

https://github.com/ruby/irb/pull/558
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/4af9bd52cbb8cff7d149a8565012ab1153a4b5b1
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/ac8a16237c727ae2a1446ef6dc810d0e750971fb
http://www.tcpdf.org

